--
-- PostgreSQL database dump
--

-- Dumped from database version 9.2.18
-- Dumped by pg_dump version 9.2.18
-- Started on 2017-10-26 14:02:54 BST

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 3007 (class 1262 OID 26325)
-- Name: instant3Dhub; Type: DATABASE; Schema: -; Owner: postgres
--

CREATE DATABASE "instant3Dhub" WITH TEMPLATE = template1 ENCODING = '{{ pgsql_locale_encoding }}' LC_COLLATE = '{{ pgsql_lc_collate }}' LC_CTYPE = '{{ pgsql_lc_ctype }}';


ALTER DATABASE "instant3Dhub" OWNER TO i3dhub;

\connect "instant3Dhub"

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = l3d, pg_catalog, extensions;

SET default_tablespace = '';

SET default_with_oids = false;



CREATE SCHEMA l3d;


ALTER SCHEMA l3d OWNER TO i3dhub;

ALTER ROLE i3dhub SET search_path TO l3d, extensions;
--
-- TOC entry 169 (class 1259 OID 26326)
-- Name: ir3d_AUXNode; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.aux_node (
    id bigint NOT NULL,
    aux_node_type_id integer,
    cache_id integer,
    ext_aux_node_id integer,
    label character varying
);


ALTER TABLE l3d.aux_node OWNER TO i3dhub;

CREATE INDEX index_aux_node_cache_id ON l3d.aux_node USING btree (cache_id);

-- Table: l3d."ir3d_AUXNode_Successor_Predecessor"

-- DROP TABLE l3d."ir3d_AUXNode_Successor_Predecessor";

CREATE TABLE l3d.aux_node_to_aux_node
(
    succ_id integer NOT NULL,
    pred_id integer NOT NULL,
    CONSTRAINT "PK_Succ_Pred_AUX" PRIMARY KEY (succ_id, pred_id)
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

ALTER TABLE l3d.aux_node_to_aux_node
    OWNER to i3dhub;

CREATE INDEX index_aux_node_to_aux_node_pred_id ON l3d.aux_node_to_aux_node USING btree (pred_id);
CREATE INDEX index_aux_node_to_aux_node_succ_id ON l3d.aux_node_to_aux_node USING btree (succ_id);


CREATE TABLE l3d.foreign_face_link
(
       id bigint not null, -- unique id
       face_link varchar not null,
       aux_node_id integer  not null -- reference to aux node,           
);
 
CREATE INDEX idx_foreign_face_link_aux_node ON foreign_face_link(aux_node_id);
 
-- Column comments
COMMENT ON COLUMN l3d.foreign_face_link.aux_node_id IS 'Reference to aux node';
COMMENT ON COLUMN l3d.foreign_face_link.face_link IS 'face link';
 
-- Permissions
ALTER TABLE l3d.foreign_face_link OWNER TO i3dhub;
GRANT ALL ON TABLE l3d.foreign_face_link TO i3dhub;

--
-- TOC entry 3011 (class 0 OID 0)
-- Dependencies: 169
-- Name: COLUMN l3d.aux_node.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node.id IS 'Unique ID';


--
-- TOC entry 3012 (class 0 OID 0)
-- Dependencies: 169
-- Name: COLUMN l3d.aux_node.aux_node_type_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node.aux_node_type_id IS 'Reference to node types ';


--
-- TOC entry 3013 (class 0 OID 0)
-- Dependencies: 169
-- Name: COLUMN l3d.aux_node.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node.cache_id IS 'Reference to cache';


--
-- TOC entry 3014 (class 0 OID 0)
-- Dependencies: 169
-- Name: COLUMN l3d.aux_node.aux_node_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node.ext_aux_node_id IS 'AUX Node ID from l3dgen';


--
-- TOC entry 170 (class 1259 OID 26329)
-- Name: AUXNode_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.aux_node_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.aux_node_id_seq OWNER TO i3dhub;

--
-- TOC entry 3015 (class 0 OID 0)
-- Dependencies: 170
-- Name: AUXNode_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.aux_node_id_seq OWNED BY l3d.aux_node.id;


CREATE SEQUENCE l3d.aux_foreign_face_link_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.aux_foreign_face_link_id_seq OWNER TO i3dhub;
ALTER SEQUENCE l3d.aux_foreign_face_link_id_seq OWNED BY l3d.foreign_face_link.id;

--
-- TOC entry 171 (class 1259 OID 26331)
-- Name: ir3d_Cache; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.cache (
    id integer NOT NULL,
    ext_cache_id0 integer,
    ext_cache_id1 integer,
    uuid character varying(200) NOT NULL,
    active boolean DEFAULT true
);


ALTER TABLE l3d.cache OWNER TO i3dhub;




--
-- TOC entry 3016 (class 0 OID 0)
-- Dependencies: 171
-- Name: COLUMN l3d.cache.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.cache.id IS 'Unique ID';


--
-- TOC entry 3017 (class 0 OID 0)
-- Dependencies: 171
-- Name: COLUMN l3d.cache.ext_cache_id0; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.cache.ext_cache_id0 IS 'First part of the cache ID (Directory level 1)';


--
-- TOC entry 3018 (class 0 OID 0)
-- Dependencies: 171
-- Name: COLUMN l3d.cache.ext_cache_id1; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.cache.ext_cache_id1 IS 'Second part of the cache ID (Directory level 2)';


--
-- TOC entry 3019 (class 0 OID 0)
-- Dependencies: 171
-- Name: COLUMN l3d.cache."UUID"; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.cache.uuid IS 'UUID identify one installation of the hub';


--
-- TOC entry 172 (class 1259 OID 26334)
-- Name: L3D_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.cache_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.cache_id_seq OWNER TO i3dhub;

--
-- TOC entry 3020 (class 0 OID 0)
-- Dependencies: 172
-- Name: L3D_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.cache_id_seq OWNED BY l3d.cache.id;


--
-- TOC entry 173 (class 1259 OID 26336)
-- Name: ir3d_AUXNodeType; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.aux_node_type (
    id integer NOT NULL,
    name character varying(50) NOT NULL
);


ALTER TABLE l3d.aux_node_type OWNER TO i3dhub;

--
-- TOC entry 3021 (class 0 OID 0)
-- Dependencies: 173
-- Name: COLUMN l3d.aux_node_type.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node_type.id IS 'Unique ID';


--
-- TOC entry 3022 (class 0 OID 0)
-- Dependencies: 173
-- Name: COLUMN l3d.aux_node_type.name; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_node_type.name IS 'Name of the type';


--
-- TOC entry 174 (class 1259 OID 26339)
-- Name: PMIGroupType_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.aux_node_type_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.aux_node_type_id_seq OWNER TO i3dhub;

--
-- TOC entry 3023 (class 0 OID 0)
-- Dependencies: 174
-- Name: PMIGroupType_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.aux_node_type_id_seq OWNED BY l3d.aux_node_type.id;


--
-- TOC entry 175 (class 1259 OID 26341)
-- Name: ir3d_AUXValueName; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.aux_value_name (
    id integer NOT NULL,
    name character varying NOT NULL
);


ALTER TABLE l3d.aux_value_name OWNER TO i3dhub;

--
-- TOC entry 3024 (class 0 OID 0)
-- Dependencies: 175
-- Name: COLUMN l3d.aux_value_name.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value_name.id IS 'Unique ID';


--
-- TOC entry 3025 (class 0 OID 0)
-- Dependencies: 175
-- Name: COLUMN l3d.aux_value_name.name; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value_name.name IS 'Name of the type';


--
-- TOC entry 176 (class 1259 OID 26344)
-- Name: PMIType_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE aux_value_name_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.aux_value_name_id_seq OWNER TO i3dhub;

--
-- TOC entry 3026 (class 0 OID 0)
-- Dependencies: 176
-- Name: PMIType_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE aux_value_name_id_seq OWNED BY l3d.aux_value_name.id;


--
-- TOC entry 177 (class 1259 OID 26348)
-- Name: ir3d_Shape; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.shape (
    id integer NOT NULL,
    cache_id integer,
    ext_shape_id integer
);


ALTER TABLE l3d.shape OWNER TO i3dhub;

--
-- TOC entry 3027 (class 0 OID 0)
-- Dependencies: 177
-- Name: COLUMN shape.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape.id IS 'Unique ID';


--
-- TOC entry 3028 (class 0 OID 0)
-- Dependencies: 177
-- Name: COLUMN shape.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape.cache_id IS 'Reference to cache';


--
-- TOC entry 3029 (class 0 OID 0)
-- Dependencies: 177
-- Name: COLUMN shape.ext_shape_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape.ext_shape_id IS 'Assigned ID from l3dgen';


--
-- TOC entry 178 (class 1259 OID 26351)
-- Name: Shape_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.shape_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.shape_id_seq OWNER TO i3dhub;

--
-- TOC entry 3030 (class 0 OID 0)
-- Dependencies: 178
-- Name: Shape_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.shape_id_seq OWNED BY shape.id;


--
-- TOC entry 179 (class 1259 OID 26353)
-- Name: ir3d_AUXValue; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.aux_value (
    id bigint NOT NULL,
    aux_value_name_id integer NOT NULL,
    value_str character varying,
    value_num numeric,	 
    aux_node_id integer
);


ALTER TABLE l3d.aux_value OWNER TO i3dhub;

--
-- TOC entry 3031 (class 0 OID 0)
-- Dependencies: 179
-- Name: COLUMN l3d.aux_value.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value.id IS 'Unique ID';


--
-- TOC entry 3032 (class 0 OID 0)
-- Dependencies: 179
-- Name: COLUMN l3d.aux_value.aux_value_name_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value.aux_value_name_id IS 'Reference to the value type';


--
-- TOC entry 3033 (class 0 OID 0)
-- Dependencies: 179
-- Name: COLUMN l3d.aux_value.value; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value.value_str IS 'The actual value';


--
-- TOC entry 3034 (class 0 OID 0)
-- Dependencies: 179
-- Name: COLUMN l3d.aux_value.aux_node_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.aux_value.aux_node_id IS 'Reference to aux node';


--
-- TOC entry 180 (class 1259 OID 26359)
-- Name: ir3d_AUXValue_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.aux_value_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.aux_value_id_seq OWNER TO i3dhub;

--
-- TOC entry 3035 (class 0 OID 0)
-- Dependencies: 180
-- Name: ir3d_AUXValue_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.aux_value_id_seq OWNED BY l3d.aux_value.id;


--
-- TOC entry 181 (class 1259 OID 26361)
-- Name: ir3d_Edge; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.edge (
    id bigint NOT NULL,
    ext_edge_id integer,
    shape_id integer,
    cache_id integer
);


ALTER TABLE l3d.edge OWNER TO i3dhub;

--
-- TOC entry 3036 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN l3d.edge.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge.id IS 'Unique ID';


--
-- TOC entry 3037 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN l3d.edge.ext_edge_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge.ext_edge_id IS 'Assigned id from l3dgen';


--
-- TOC entry 3038 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN l3d.edge.shape_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge.shape_id IS 'Reference to the shape';


--
-- TOC entry 3039 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN l3d.edge.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge.cache_id IS 'Reference to the cache';


--
-- TOC entry 182 (class 1259 OID 26364)
-- Name: ir3d_EdgeInstance; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.edge_instance (
    id bigint NOT NULL,
    edge_id integer,
    cache_id integer,
    shape_instance_id integer
);


ALTER TABLE l3d.edge_instance OWNER TO i3dhub;

--
-- TOC entry 3040 (class 0 OID 0)
-- Dependencies: 182
-- Name: COLUMN l3d.edge_instance.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance.id IS 'Unique ID';


--
-- TOC entry 3041 (class 0 OID 0)
-- Dependencies: 182
-- Name: COLUMN l3d.edge_instance.edge_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance.edge_id IS 'Reference to edge';


--
-- TOC entry 3042 (class 0 OID 0)
-- Dependencies: 182
-- Name: COLUMN l3d.edge_instance.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance.cache_id IS 'Reference to cache';


--
-- TOC entry 3043 (class 0 OID 0)
-- Dependencies: 182
-- Name: COLUMN l3d.edge_instance.shape_instance_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance.shape_instance_id IS 'Reference to shape instance';


--
-- TOC entry 183 (class 1259 OID 26367)
-- Name: ir3d_EdgeInstance_AuxNode; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.edge_instance_to_aux_node (
    aux_node_id bigint NOT NULL,
    edge_instance_id bigint NOT NULL
);


ALTER TABLE l3d.edge_instance_to_aux_node OWNER TO i3dhub;

--
-- TOC entry 3044 (class 0 OID 0)
-- Dependencies: 183
-- Name: COLUMN l3d.edge_instance_to_aux_node.aux_node_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance_to_aux_node.aux_node_id IS 'Reference to aux node';


--
-- TOC entry 3045 (class 0 OID 0)
-- Dependencies: 183
-- Name: COLUMN l3d.edge_instance_to_aux_node.edge_instance_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.edge_instance_to_aux_node.edge_instance_id IS 'Reference to edge instance';


--
-- TOC entry 184 (class 1259 OID 26370)
-- Name: ir3d_EdgeInstance_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.edge_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.edge_instance_id_seq OWNER TO i3dhub;

--
-- TOC entry 3046 (class 0 OID 0)
-- Dependencies: 184
-- Name: ir3d_EdgeInstance_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.edge_instance_id_seq OWNED BY l3d.edge_instance.id;


--
-- TOC entry 185 (class 1259 OID 26372)
-- Name: ir3d_Edge_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.edge_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.edge_id_seq OWNER TO i3dhub;

--
-- TOC entry 3047 (class 0 OID 0)
-- Dependencies: 185
-- Name: ir3d_Edge_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.edge_id_seq OWNED BY l3d.edge.id;


--
-- TOC entry 186 (class 1259 OID 26374)
-- Name: ir3d_Face; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.face (
    id bigint NOT NULL,
    shape_id integer,
    ext_face_id integer,
    cache_id integer
);


ALTER TABLE l3d.face OWNER TO i3dhub;

--
-- TOC entry 3048 (class 0 OID 0)
-- Dependencies: 186
-- Name: COLUMN l3d.face.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face.id IS 'Unique ID';


--
-- TOC entry 3049 (class 0 OID 0)
-- Dependencies: 186
-- Name: COLUMN l3d.face.shape_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face.shape_id IS 'Reference to shape';


--
-- TOC entry 3050 (class 0 OID 0)
-- Dependencies: 186
-- Name: COLUMN l3d.face.ext_face_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face.ext_face_id IS 'Assigned Id from l3dgen';


--
-- TOC entry 3051 (class 0 OID 0)
-- Dependencies: 186
-- Name: COLUMN l3d.face.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face.cache_id IS 'Reference to cache';


--
-- TOC entry 187 (class 1259 OID 26377)
-- Name: ir3d_FaceInstance_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.face_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.face_instance_id_seq OWNER TO i3dhub;

--
-- TOC entry 188 (class 1259 OID 26379)
-- Name: ir3d_FaceInstance; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.face_instance (
    id integer DEFAULT nextval('l3d.face_instance_id_seq'::regclass) NOT NULL,
    face_id integer,
    cache_id integer,
    shape_instance_id integer
);


ALTER TABLE l3d.face_instance OWNER TO i3dhub;

--
-- TOC entry 3052 (class 0 OID 0)
-- Dependencies: 188
-- Name: COLUMN l3d.edge_instance_to_aux_node.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance.id IS 'Unique ID';


--
-- TOC entry 3053 (class 0 OID 0)
-- Dependencies: 188
-- Name: COLUMN l3d.edge_instance_to_aux_node.face_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance.face_id IS 'Reference to face';


--
-- TOC entry 3054 (class 0 OID 0)
-- Dependencies: 188
-- Name: COLUMN l3d.edge_instance_to_aux_node.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance.cache_id IS 'Reference to cache';


--
-- TOC entry 3055 (class 0 OID 0)
-- Dependencies: 188
-- Name: COLUMN l3d.edge_instance_to_aux_node.shape_instance_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance.shape_instance_id IS 'Reference to shape instance';


--
-- TOC entry 189 (class 1259 OID 26383)
-- Name: ir3d_FaceInstance_AuxNode; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.face_instance_to_aux_node (
    aux_node_id integer NOT NULL,
    face_instance_id integer NOT NULL
);


ALTER TABLE l3d.face_instance_to_aux_node OWNER TO i3dhub;

CREATE INDEX idx_face_instance_to_aux_node_face_id ON l3d.face_instance_to_aux_node USING btree (face_instance_id);

--
-- TOC entry 3056 (class 0 OID 0)
-- Dependencies: 189
-- Name: COLUMN l3d.face_instance_to_aux_node.aux_node_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance_to_aux_node.aux_node_id IS 'Referecen to aux node';


--
-- TOC entry 3057 (class 0 OID 0)
-- Dependencies: 189
-- Name: COLUMN l3d.face_instance_to_aux_node.face_instance_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.face_instance_to_aux_node.face_instance_id IS 'Reference to face instance';



CREATE TABLE l3d.face_instance_to_original (
       face_instance_id int4 NOT NULL, -- Reference to face instance
       original_face_id int4 NOT NULL, -- original face id
       CONSTRAINT pk_face_instance_to_original PRIMARY KEY (face_instance_id)
);

CREATE INDEX idx_face_instance_to_original_face ON face_instance_to_original(original_face_id);
 
-- Column comments
COMMENT ON COLUMN l3d.face_instance_to_original.face_instance_id IS 'Reference to face instance';
COMMENT ON COLUMN l3d.face_instance_to_original.original_face_id IS 'Original face ID';
 
-- Permissions
 
ALTER TABLE l3d.face_instance_to_original OWNER TO i3dhub;
GRANT ALL ON TABLE l3d.face_instance_to_original TO i3dhub;



--
-- TOC entry 190 (class 1259 OID 26386)
-- Name: ir3d_Face_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.face_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.face_id_seq OWNER TO i3dhub;

--
-- TOC entry 3058 (class 0 OID 0)
-- Dependencies: 190
-- Name: ir3d_Face_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.face_id_seq OWNED BY l3d.face.id;


--
-- TOC entry 191 (class 1259 OID 26388)
-- Name: ir3d_Node; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.node (
    id integer NOT NULL,
    ext_node_id integer NOT NULL,
    parent_node_id integer,
    cache_id integer,
    label character varying
);


ALTER TABLE l3d.node OWNER TO i3dhub;


--
-- TOC entry 3059 (class 0 OID 0)
-- Dependencies: 191
-- Name: COLUMN l3d.node.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.node.id IS 'Unique ID';


--
-- TOC entry 3060 (class 0 OID 0)
-- Dependencies: 191
-- Name: COLUMN l3d.node."Node_ID"; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.node.ext_node_id IS 'Assigned ID from l3dgen';


--
-- TOC entry 3061 (class 0 OID 0)
-- Dependencies: 191
-- Name: COLUMN l3d.node.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.node.cache_id IS 'Reference to cache';


--
-- TOC entry 3062 (class 0 OID 0)
-- Dependencies: 191
-- Name: COLUMN l3d.node.label; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.node.label IS 'Name of the node';


--
-- TOC entry 192 (class 1259 OID 26391)
-- Name: ir3d_Node_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.node_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.node_id_seq OWNER TO i3dhub;

--
-- TOC entry 3063 (class 0 OID 0)
-- Dependencies: 192
-- Name: ir3d_Node_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.node_id_seq OWNED BY l3d.node.id;


--
-- TOC entry 193 (class 1259 OID 26393)
-- Name: ir3d_ShapeInstance; Type: TABLE; Schema: l3d; Owner: i3dhub; Tablespace: 
--

CREATE TABLE l3d.shape_instance (
    id integer NOT NULL,
    shape_instance_id integer,
    cache_id integer,
    shape_id integer,
    node_id integer
);


ALTER TABLE l3d.shape_instance OWNER TO i3dhub;

--
-- TOC entry 3064 (class 0 OID 0)
-- Dependencies: 193
-- Name: COLUMN l3d.shape_instance.id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape_instance.id IS 'Unique ID';


--
-- TOC entry 3065 (class 0 OID 0)
-- Dependencies: 193
-- Name: COLUMN l3d.shape_instance.shape_instance_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape_instance.shape_instance_id IS 'Assigned Id from l3dgen';


--
-- TOC entry 3066 (class 0 OID 0)
-- Dependencies: 193
-- Name: COLUMN l3d.shape_instance.cache_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape_instance.cache_id IS 'Reference to cache';


--
-- TOC entry 3067 (class 0 OID 0)
-- Dependencies: 193
-- Name: COLUMN l3d.shape_instance.shape_id; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape_instance.shape_id IS 'Reference to shape';


--
-- TOC entry 3068 (class 0 OID 0)
-- Dependencies: 193
-- Name: COLUMN l3d.shape_instance."Node_ID"; Type: COMMENT; Schema: l3d; Owner: i3dhub
--

COMMENT ON COLUMN l3d.shape_instance.node_id IS 'Reference to node';


--
-- TOC entry 194 (class 1259 OID 26396)
-- Name: ir3d_ShapeInstance_ID_seq; Type: SEQUENCE; Schema: l3d; Owner: i3dhub
--

CREATE SEQUENCE l3d.shape_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE l3d.shape_instance_id_seq OWNER TO i3dhub;

--
-- TOC entry 3069 (class 0 OID 0)
-- Dependencies: 194
-- Name: ir3d_ShapeInstance_ID_seq; Type: SEQUENCE OWNED BY; Schema: l3d; Owner: i3dhub
--

ALTER SEQUENCE l3d.shape_instance_id_seq OWNED BY l3d.shape_instance.id;


--
-- TOC entry 2832 (class 2604 OID 26398)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_node ALTER COLUMN id SET DEFAULT nextval('l3d.aux_node_id_seq'::regclass);


ALTER TABLE ONLY l3d.foreign_face_link ALTER COLUMN id SET DEFAULT nextval('l3d.aux_foreign_face_link_id_seq'::regclass);


--
-- TOC entry 2834 (class 2604 OID 26965)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_node_type ALTER COLUMN id SET DEFAULT nextval('l3d.aux_node_type_id_seq'::regclass);


--
-- TOC entry 2837 (class 2604 OID 26400)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_value ALTER COLUMN id SET DEFAULT nextval('l3d.aux_value_id_seq'::regclass);


--
-- TOC entry 2835 (class 2604 OID 26903)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_value_name ALTER COLUMN id SET DEFAULT nextval('aux_value_name_id_seq'::regclass);


--
-- TOC entry 2833 (class 2604 OID 26615)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.cache ALTER COLUMN id SET DEFAULT nextval('l3d.cache_id_seq'::regclass);


--
-- TOC entry 2838 (class 2604 OID 26404)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge ALTER COLUMN id SET DEFAULT nextval('l3d.edge_id_seq'::regclass);


--
-- TOC entry 2839 (class 2604 OID 26405)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance ALTER COLUMN id SET DEFAULT nextval('l3d.edge_instance_id_seq'::regclass);


--
-- TOC entry 2840 (class 2604 OID 26406)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face ALTER COLUMN id SET DEFAULT nextval('l3d.face_id_seq'::regclass);


--
-- TOC entry 2842 (class 2604 OID 26795)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.node ALTER COLUMN id SET DEFAULT nextval('l3d.node_id_seq'::regclass);


--
-- TOC entry 2836 (class 2604 OID 26820)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY shape ALTER COLUMN id SET DEFAULT nextval('l3d.shape_id_seq'::regclass);


--
-- TOC entry 2843 (class 2604 OID 26855)
-- Name: ID; Type: DEFAULT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.shape_instance ALTER COLUMN id SET DEFAULT nextval('l3d.shape_instance_id_seq'::regclass);


--
-- TOC entry 2849 (class 2606 OID 26967)
-- Name: PK_AUXGroup_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.aux_node_type
    ADD CONSTRAINT pk_aux_node_type_id PRIMARY KEY (id);


--
-- TOC entry 2845 (class 2606 OID 26413)
-- Name: PK_AUXNode_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.aux_node
    ADD CONSTRAINT pk_aux_node_id PRIMARY KEY (id);


--
-- TOC entry 2851 (class 2606 OID 26905)
-- Name: PK_AUXType_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.aux_value_name
    ADD CONSTRAINT pk_aux_value_name_id PRIMARY KEY (id);


--
-- TOC entry 2856 (class 2606 OID 26417)
-- Name: PK_AUXValue_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.aux_value
    ADD CONSTRAINT pk_aux_value_id PRIMARY KEY (id);


--
-- TOC entry 2860 (class 2606 OID 26419)
-- Name: PK_EdgeInstanceID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.edge_instance
    ADD CONSTRAINT pk_edge_instance_ud PRIMARY KEY (id);


--
-- TOC entry 2862 (class 2606 OID 26421)
-- Name: PK_EdgeInstance_AuxNode; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.edge_instance_to_aux_node
    ADD CONSTRAINT pk_edge_instance_to_aux_node_id PRIMARY KEY (aux_node_id, edge_instance_id);


--
-- TOC entry 2858 (class 2606 OID 26423)
-- Name: PK_Edge_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.edge
    ADD CONSTRAINT pk_edge_id PRIMARY KEY (id);


--
-- TOC entry 2868 (class 2606 OID 26785)
-- Name: PK_FaceInstance_AUXNode; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.face_instance_to_aux_node
    ADD CONSTRAINT pk_face_instance_to_aux_node_id PRIMARY KEY (aux_node_id, face_instance_id);


--
-- TOC entry 2866 (class 2606 OID 26735)
-- Name: PK_FaceInstance_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.face_instance
    ADD CONSTRAINT pk_face_instance_id PRIMARY KEY (id);


--
-- TOC entry 2864 (class 2606 OID 26429)
-- Name: PK_Face_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.face
    ADD CONSTRAINT pk_face_id PRIMARY KEY (id);


--
-- TOC entry 2847 (class 2606 OID 26617)
-- Name: PK_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.cache
    ADD CONSTRAINT pk_id PRIMARY KEY (id);


--
-- TOC entry 2870 (class 2606 OID 26797)
-- Name: PK_Node_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.node
    ADD CONSTRAINT pk_node_id PRIMARY KEY (id);


--
-- TOC entry 2872 (class 2606 OID 26857)
-- Name: PK_ShapeInstance_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY l3d.shape_instance
    ADD CONSTRAINT pk_shape_instance_id PRIMARY KEY (id);


--
-- TOC entry 2853 (class 2606 OID 26822)
-- Name: PK_Shape_ID; Type: CONSTRAINT; Schema: l3d; Owner: i3dhub; Tablespace: 
--

ALTER TABLE ONLY shape
    ADD CONSTRAINT pk_shape_id PRIMARY KEY (id);



--
-- TOC entry 2890 (class 2606 OID 26775)
-- Name: FK_AUXNode; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face_instance_to_aux_node
    ADD CONSTRAINT fk_aux_node_id FOREIGN KEY (aux_node_id) REFERENCES l3d.aux_node(id) ON DELETE CASCADE;


--
-- TOC entry 2874 (class 2606 OID 26968)
-- Name: FK_AUXNodeType_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_node
    ADD CONSTRAINT fk_aux_node_type_id FOREIGN KEY (aux_node_type_id) REFERENCES l3d.aux_node_type(id);


--
-- TOC entry 2883 (class 2606 OID 26459)
-- Name: FK_AUXNode_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance_to_aux_node
    ADD CONSTRAINT fk_aux_node_id FOREIGN KEY (aux_node_id) REFERENCES l3d.aux_node(id) ON DELETE CASCADE;


--
-- TOC entry 2877 (class 2606 OID 26929)
-- Name: FK_AUXNode_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_value
    ADD CONSTRAINT fk_aux_node_id FOREIGN KEY (aux_node_id) REFERENCES l3d.aux_node(id) ON DELETE CASCADE;

ALTER TABLE ONLY l3d.foreign_face_link
    ADD CONSTRAINT fk_foreign_face_link_aux_node FOREIGN KEY (aux_node_id) REFERENCES l3d.aux_node(id);

--
-- TOC entry 2876 (class 2606 OID 26915)
-- Name: FK_AUXValueName_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_value
    ADD CONSTRAINT fk_aux_value_name_id FOREIGN KEY (aux_value_name_id) REFERENCES l3d.aux_value_name(id);


--
-- TOC entry 2878 (class 2606 OID 26675)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2881 (class 2606 OID 26693)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2885 (class 2606 OID 26724)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2888 (class 2606 OID 26754)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face_instance
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2892 (class 2606 OID 26811)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.node
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2875 (class 2606 OID 26842)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY shape
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2893 (class 2606 OID 26876)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.shape_instance
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2873 (class 2606 OID 26952)
-- Name: FK_Cache_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.aux_node
    ADD CONSTRAINT fk_cache_id FOREIGN KEY (cache_id) REFERENCES l3d.cache(id) ON DELETE CASCADE;


--
-- TOC entry 2884 (class 2606 OID 26509)
-- Name: FK_EdgeInstance_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance_to_aux_node
    ADD CONSTRAINT fk_edge_instance_id FOREIGN KEY (edge_instance_id) REFERENCES l3d.edge_instance(id) ON DELETE CASCADE;


--
-- TOC entry 2880 (class 2606 OID 26684)
-- Name: FK_Edge_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance
    ADD CONSTRAINT fk_edge_id FOREIGN KEY (edge_id) REFERENCES l3d.edge(id) ON DELETE CASCADE;


--
-- TOC entry 2891 (class 2606 OID 26786)
-- Name: FK_FaceInstance_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face_instance_to_aux_node
    ADD CONSTRAINT fk_face_instance_id FOREIGN KEY (face_instance_id) REFERENCES l3d.face_instance(id) ON DELETE CASCADE;

ALTER TABLE ONLY l3d.face_instance_to_original
    ADD CONSTRAINT fk_original_face_instance_id FOREIGN KEY (face_instance_id) REFERENCES l3d.face_instance(id);

--
-- TOC entry 2887 (class 2606 OID 26745)
-- Name: FK_Face_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face_instance
    ADD CONSTRAINT fk_face_id FOREIGN KEY (face_id) REFERENCES l3d.face(id) ON DELETE CASCADE;


--
-- TOC entry 2895 (class 2606 OID 26894)
-- Name: FK_Node_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.shape_instance
    ADD CONSTRAINT fk_node_id FOREIGN KEY (node_id) REFERENCES l3d.node(id) ON DELETE CASCADE;


--
-- TOC entry 2882 (class 2606 OID 26858)
-- Name: FK_ShapeInstance_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge_instance
    ADD CONSTRAINT fk_shape_instance_id FOREIGN KEY (shape_instance_id) REFERENCES l3d.shape_instance(id) ON DELETE CASCADE;


--
-- TOC entry 2889 (class 2606 OID 26863)
-- Name: FK_ShapeInstance_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face_instance
    ADD CONSTRAINT fk_shape_instance_id FOREIGN KEY (shape_instance_id) REFERENCES l3d.shape_instance(id) ON DELETE CASCADE;


--
-- TOC entry 2879 (class 2606 OID 26828)
-- Name: FK_Shape_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.edge
    ADD CONSTRAINT fk_shape_id FOREIGN KEY (shape_id) REFERENCES shape(id);


--
-- TOC entry 2886 (class 2606 OID 26833)
-- Name: FK_Shape_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.face
    ADD CONSTRAINT fk_shape_id FOREIGN KEY (shape_id) REFERENCES shape(id) ON DELETE CASCADE;


--
-- TOC entry 2894 (class 2606 OID 26885)
-- Name: FK_Shape_ID; Type: FK CONSTRAINT; Schema: l3d; Owner: i3dhub
--

ALTER TABLE ONLY l3d.shape_instance
    ADD CONSTRAINT fk_shape_id FOREIGN KEY (shape_id) REFERENCES shape(id) ON DELETE CASCADE;



--
-- Add Indexes 
--




-- Index: Edge_Cache_Index

-- DROP INDEX l3d.cache_id;

CREATE INDEX edge_to_cache_index
    ON l3d.edge USING btree
    (cache_id)
    TABLESPACE pg_default;

-- Index: EdgeInstance_Cache_Index

-- DROP INDEX l3d.edge_instance_to_cache_index;

CREATE INDEX edge_instance_to_cache_index
    ON l3d.edge_instance USING btree
    (cache_id)
    TABLESPACE pg_default;


-- Index: Face_Cache_Index

-- DROP INDEX l3d.face_to_cache_index;

CREATE INDEX face_to_cache_index
    ON l3d.face USING btree
    (cache_id,ext_face_id)
    TABLESPACE pg_default;


-- Index: FaceInstance_Cache_Index

-- DROP INDEX l3dface_instance_to_cache_index;

CREATE INDEX face_instance_to_cache_index
    ON l3d.face_instance USING btree
    (cache_id)
    TABLESPACE pg_default;


-- Index: Node_Cache_Index

-- DROP INDEX l3dnode_to_cache_index;

CREATE INDEX node_to_cache_index
    ON l3d.node USING btree
    (cache_id,ext_node_id)
    TABLESPACE pg_default;


-- Index: Shape_Cache_Index

-- DROP INDEX l3dshape_to_cache_index;

CREATE INDEX shape_to_cache_index
    ON l3d.shape USING btree
    (cache_id)
    TABLESPACE pg_default;

-- Index: ShapeInstance_Cache_Index

-- DROP INDEX l3dshape_instance_cache_index;

CREATE INDEX shape_instance_to_cache_index
    ON l3d.shape_instance USING btree
    (cache_id)
    TABLESPACE pg_default;



-- Index: index_cache_uuid

-- DROP INDEX l3d.index_cache_uuid;

CREATE INDEX index_cache_uuid
    ON l3d.cache USING btree
    (uuid COLLATE pg_catalog."default", ext_cache_id0, ext_cache_id1, active)
    TABLESPACE pg_default;


-- Table: l3d.aux_attributes

-- DROP TABLE l3d.aux_attributes;

CREATE TABLE l3d.aux_attributes
(
    key character varying COLLATE pg_catalog."default",
    value character varying COLLATE pg_catalog."default",
    aux_node_id integer,
    CONSTRAINT fk_aux_node_id FOREIGN KEY (aux_node_id)
        REFERENCES l3d.aux_node (id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

ALTER TABLE l3d.aux_attributes
    OWNER to i3dhub;


-- Table: l3d.metadata

-- DROP TABLE l3d.metadata;

CREATE TABLE l3d.metadata
(
    key character varying COLLATE pg_catalog."default",

    value_str text COLLATE pg_catalog."default",
	value_num numeric,
    node_id integer,
    CONSTRAINT fk_node_id FOREIGN KEY (node_id)
        REFERENCES l3d.node (id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

ALTER TABLE l3d.metadata
    OWNER to i3dhub;

CREATE INDEX index_metadata_key_0 ON l3d.metadata USING btree (substr((key)::text, 1, 1));
CREATE INDEX index_metadata_node_id ON l3d.metadata USING btree (node_id);

--add indexes
-- CREATE INDEX index_auxvalues ON l3d.aux_value USING GIN (value_str, value_num);
CREATE INDEX index_aux_value_aux_node_id ON l3d.aux_value USING btree (aux_node_id);
--CREATE INDEX index_auxattributes ON l3d.aux_attributes USING GIN (value);
CREATE INDEX index_aux_attributes_aux_node_id ON l3d.aux_attributes USING btree (aux_node_id);

--
-- TOC entry 3009 (class 0 OID 0)
-- Dependencies: 7
-- Name: l3d; Type: ACL; Schema: -; Owner: postgres
--

-- Drop table

-- DROP TABLE l3d.tag_name

CREATE TABLE l3d.tag_name (
	id serial NOT NULL,
	name varchar NULL,
	CONSTRAINT pk_tag_name_id PRIMARY KEY (id)
)
WITH (
	OIDS=FALSE
) ;
COMMENT ON TABLE l3d.tag_name IS 'Tags of a node are key-value pairs. This table holds the name of the keys ' ;

ALTER TABLE l3d.tag_name OWNER TO i3dhub;


-- Drop table

-- DROP TABLE l3d.tags_values

CREATE TABLE l3d.tags_values (
	id bigserial NOT NULL,
	node_id int8 NULL,
	value varchar NULL,
	tag_name_id int4 NULL,
	CONSTRAINT tags_values_id PRIMARY KEY (id),
	CONSTRAINT fk_node_id FOREIGN KEY (node_id) REFERENCES l3d.node(id),
	CONSTRAINT fk_tag_name_id FOREIGN KEY (tag_name_id) REFERENCES l3d.tag_name(id)
)
WITH (
	OIDS=FALSE
) ;

CREATE INDEX idx_tags_values ON l3d.tags_values USING btree (node_id);
-- Permissions

ALTER TABLE l3d.tags_values OWNER TO i3dhub;


-- Table: l3d.data_stats

-- DROP TABLE l3d.data_stats;

CREATE TABLE l3d.data_stats
(
    cache_id integer NOT NULL,
    stats json,
    CONSTRAINT pk_data_stats_id PRIMARY KEY (cache_id),
    CONSTRAINT fk_cache_id FOREIGN KEY (cache_id)
        REFERENCES l3d.cache (id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

-- Permissions
ALTER TABLE l3d.data_stats
    OWNER to i3dhub;	


REVOKE ALL ON SCHEMA l3d FROM "i3dhub";

GRANT ALL ON SCHEMA l3d TO "i3dhub";
 

-- Completed on 2017-10-26 14:02:54 BST

--
-- PostgreSQL database dump complete
--

