CREATE OR REPLACE FUNCTION l3d.compute_cache_size(
	p_uuid character varying,
	p_cid0 integer,
	p_cid1 integer
	)
RETURNS integer
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

	DECLARE cacheId bigint = NULL;
	DECLARE cacheSize integer = NULL;
  BEGIN
  	SELECT l3d.get_cache(p_uuid,p_cid0,p_cid1) INTO cacheId;
	 SELECT COALESCE((
	(SELECT pg_column_size("id")+ pg_column_size(ext_cache_id0)+ pg_column_size(ext_cache_id1)+ pg_column_size(uuid)+ pg_column_size(active)
	FROM l3d.cache
	WHERE "id"=cacheId
	) + (	
	
	--aux node size	
	SELECT SUM(pg_column_size("id")+pg_column_size("aux_node_type_id")+pg_column_size("cache_id")+ pg_column_size("ext_aux_node_id") + pg_column_size("label") )	
	FROM l3d.aux_node
	WHERE "cache_id" = cacheId
	) + (
	-- aux attributes size
	
	SELECT SUM (pg_column_size("key")+pg_column_size("value")+pg_column_size("aux_node_id"))
	FROM l3d.aux_attributes
	WHERE "aux_node_id" IN (
		SELECT "id"
		FROM l3d.aux_node
		WHERE "cache_id" = cacheId
		)
	)+ (
		-- aux Properties 
		SELECT SUM (pg_column_size("aux_value_name_id")+pg_column_size(COALESCE("value_str","value_num"::text)) + pg_column_size("aux_node_id"))
		FROM l3d.aux_value
		WHERE "aux_node_id" IN (
		SELECT "id"
		FROM l3d.aux_node
		WHERE "cache_id" = cacheId
		)
	) + (
	
		-- l3d nodes
		SELECT SUM (pg_column_size("id")+ pg_column_size("ext_node_id")+ pg_column_size("cache_id")+ pg_column_size("label"))
		FROM l3d.node
		WHERE "cache_id" = cacheId
 	) + (
		--l3d nodes metadata1										
		SELECT SUM (pg_column_size("key")+pg_column_size("value_str")+ pg_column_size("node_id"))
		FROM l3d.metadata
		WHERE "node_id" IN (
			SELECT "id"
		    FROM l3d.aux_node
			WHERE "cache_id" = cacheId
		)
	) + (
		-- l3d nodes tags
		COALESCE ((SELECT SUM (pg_column_size("id")+ pg_column_size("node_id")+ pg_column_size("value")+ pg_column_size("tag_name_id"))
		FROM l3d.tags_values 
		WHERE "node_id" IN (
			SELECT "id"
		    FROM l3d.aux_node
			WHERE "cache_id" = cacheId
		)),0)
	) + (
		-- shapes											
		COALESCE ((
			SELECT  SUM (pg_column_size("id")+ pg_column_size ("cache_id")+pg_column_size("ext_shape_id"))
			FROM l3d.shape
		    WHERE "cache_id" = cacheId
		),0)
	) + (
	
		-- faces											
		COALESCE ((
			SELECT  SUM (pg_column_size("id")+ pg_column_size ("cache_id")+pg_column_size("shape_id")+pg_column_size("ext_face_id"))
			FROM l3d.face
		    WHERE "cache_id" = cacheId
		),0)
											
	)									
				
													
	   
	    
),0) INTO cacheSize;

RETURN cacheSize;



 END; 

$BODY$;

ALTER FUNCTION l3d.compute_cache_size(character varying, integer, integer)
    OWNER TO i3dhub;


CREATE OR REPLACE FUNCTION l3d.get_cache_size(
	p_uuid character varying,
	p_cid0 integer,
	p_cid1 integer
	)
RETURNS integer
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$

 BEGIN
  RETURN 0;
 END; 

$BODY$;

ALTER FUNCTION l3d.get_cache_size(character varying, integer, integer)
    OWNER TO i3dhub;
